/*
 * Copyright (c) 2005 Rozhuk Ivan <rozhuk.im@gmail.com>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */



#if !defined(AFX_CRCFILECHECK_H__F58D13FF_F6F2_476C_B8F0_7B9E9357CF48__INCLUDED_)
#define AFX_CRCFILECHECK_H__F58D13FF_F6F2_476C_B8F0_7B9E9357CF48__INCLUDED_


#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include <Imagehlp.h>
#pragma comment(lib,"Imagehlp.lib")



__inline DWORD CRCFileCheck()
{
	DWORD dwRetErrorCode;
	#ifdef NDEBUG
	{//    
		TCHAR szFullPath[32768];
		DWORD dwFileChecksum=0,dwRealChecksum=0;

		if (GetModuleFileName(GetModuleHandle(NULL),szFullPath,(sizeof(szFullPath)/sizeof(TCHAR))))
		{//   
			if (MapFileAndCheckSum(szFullPath,&dwFileChecksum,&dwRealChecksum)==CHECKSUM_SUCCESS)
			{//     
				if (dwFileChecksum==dwRealChecksum)
				{
					dwRetErrorCode=NO_ERROR;
				}else{
					dwRetErrorCode=ERROR_CRC;
				}
			}else{
				dwRetErrorCode=ERROR_CRC;
			}
		}else{
			dwRetErrorCode=GetLastError();
		}
	}
	#else
		dwRetErrorCode=NO_ERROR;
	#endif //_DEBUG//*/
return(dwRetErrorCode);
}




#endif // AFX_CRCFILECHECK_H__F58D13FF_F6F2_476C_B8F0_7B9E9357CF48__INCLUDED_
