/*
 * Copyright (c) 2010 Rozhuk Ivan <rozhuk.im@gmail.com>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */




#if !defined(AFX_RAWDATATOPRINTER_H__F58D13FF_F6F2_476C_B8F0_7B9E9357CF48__INCLUDED_)
#define AFX_RAWDATATOPRINTER_H__F58D13FF_F6F2_476C_B8F0_7B9E9357CF48__INCLUDED_


#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000





__inline DWORD RawDataToPrinter(LPWSTR pszPrinterName,LPWSTR pszDocName,LPBYTE pData,DWORD dwDataSize)
{
	DWORD dwRetErrorCode=ERROR_INVALID_HANDLE;

	if (pszPrinterName && pData && dwDataSize)
	{
		HANDLE hPrinter;
		DWORD dwJob,dwBytesWritten;
		DOC_INFO_1 DocInfo;

		if (OpenPrinter(pszPrinterName,&hPrinter,NULL))// Open a handle to the printer.
		{// Fill in the structure with info about this "document."
			DocInfo.pDocName=pszDocName;
			DocInfo.pOutputFile=NULL;
			DocInfo.pDatatype=L"RAW";

			dwJob=StartDocPrinter(hPrinter,1,(LPBYTE)&DocInfo);// Inform the spooler the document is beginning.
			if (dwJob>0)
			{
				if (StartPagePrinter(hPrinter))// Start a page.
				{
					dwBytesWritten=0;
					if (WritePrinter(hPrinter,pData,dwDataSize,&dwBytesWritten) && dwBytesWritten==dwDataSize)// Send the data to the printer.
					{
						dwRetErrorCode=NO_ERROR;
					}else{
						dwRetErrorCode=GetLastError();
					}
					EndPagePrinter(hPrinter);
				}else{
					dwRetErrorCode=GetLastError();
				}
				EndDocPrinter(hPrinter);// Inform the spooler that the document is ending.
			}else{
				dwRetErrorCode=GetLastError();
			}
			ClosePrinter(hPrinter);// Close the printer handle.
		}else{
			dwRetErrorCode=GetLastError();
		}
	}
return(dwRetErrorCode);
}




#endif // AFX_RAWDATATOPRINTER_H__F58D13FF_F6F2_476C_B8F0_7B9E9357CF48__INCLUDED_
